import { NgModule } from '@angular/core';
import { Routes, RouterModule } from '@angular/router';
import {AuthGuard} from "./core/auth-guard.service";

const appRoutes: Routes = [
  { path: 'dashboard', loadChildren: './dashboard/dashboard.module#DashboardModule?sync=true' },
  { path: 'login', loadChildren: './login/login.module#LoginModule?sync=true' },
  { path: 'devices',loadChildren: './devices/devices.module#DevicesModule'/*,canLoad:AuthGuard*/},
  { path: 'sites', loadChildren: './sites/sites.module#SitesModule' },
  { path: '', redirectTo: '/dashboard',pathMatch:'full' }
];


@NgModule({
  imports: [RouterModule.forRoot(appRoutes)],
  exports: [RouterModule],
})
export class AppRoutingModule { }



