import { Injectable } from '@angular/core';
import {Headers, Http, Response, RequestOptionsArgs} from '@angular/http';

import 'rxjs/add/operator/toPromise';

import { Observable } from 'rxjs/Rx';
import 'rxjs/add/operator/map';
import 'rxjs/add/operator/catch';
import {LoginResponseVO} from "./models/LoginResponseVO";
import {LoginRequestVO} from "./models/LoginRequestVO";



@Injectable()
export class LoginService {

  constructor(private http: Http) { }

  login(loginVO:LoginRequestVO): Observable<any[]> {
    let body = JSON.stringify(loginVO);
    let options: RequestOptionsArgs = <RequestOptionsArgs>{};
    options.url = 'http://localhost:8081/login';    //todo .. this should come from a config file...or a parent class
    options.headers=  new Headers({       //todo ... this should come from a util... or consider extending HTTP .. jwt token also to be added
      'Accept': 'application/json',
      'Content-Type': 'application/json'
    });

    return this.http.post(``, body, options)
        .map((r: Response) => r.json().data as LoginResponseVO)
        .catch(this.handleObservableError);
  }

  handleObservableError(error:any){
    console.error(error.status);
    return Observable.throw(error.json().error || 'Unknown server error');  // todo ... what after throwing error ?
  }

}